<template>
  <div id="PurchaseDemandList">
    <div v-if="isList">
      <el-form class="search_area" label-width="100px">
        <el-row :gutter="10">
          <el-col :span="1.5">
            <el-form-item label="单据编码">
              <el-input
                v-model.trim="queryParams.code"
                size="small"
                clearable
                style="width: 200px"
              />
            </el-form-item>
          </el-col>
          <el-col :span="1.5">
            <el-form-item label="需求客户">
              <el-select clearable size="small" v-model="queryParams.customer" @focus="chooseOrg('CUSTOMER_PARAM', true, '选择客户')" style="width: 200px">
                <el-option v-for="item in customerOptions" :key="item.id" :label="item.name" :value="item.id" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="1.5">
            <el-form-item label="是否客户指定">
              <el-select clearable v-model="queryParams.isProcess" size="small" style="width: 200px" placeholder="请选择">
                <el-option
                  v-for="item in options"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="1.5">
            <el-form-item label="" label-width="20px">
              <el-button type="primary" size="small" icon="el-icon-search" plain @click="searchList">搜索</el-button>
              <el-button size="small" icon="el-icon-refresh" plain @click="resetList">重置</el-button>
            </el-form-item>
          </el-col>
        </el-row>
      <CollapseTransition>
        <div v-show="expanded">
        <el-row :gutter="10">
          <el-col :span="1.5">
            <el-form-item label="需求人员">
              <el-select clearable size="small" v-model="queryParams.demandPersonal" @focus="chooseOrg('CONTACTS_PARAM', true, '需求人员')" style="width: 200px">
                <el-option v-for="item in personOptions" :key="item.id" :label="item.name" :value="item.id" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="1.5">
            <el-form-item label="单据来源">
              <el-select clearable v-model="queryParams.source" size="small" style="width: 200px">
                <el-option v-for="dict in dict.type.sys_bill_source" :key="dict.value" :label="dict.label" :value="dict.value">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="1.5">
            <el-form-item label="业务类型">
              <el-select clearable v-model="queryParams.billType" size="small" style="width: 200px">
                <el-option v-for=" dict in dict.type.sys_business" :key="dict.value" :label="dict.label" :value="dict.value">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row :gutter="10">
          <el-col :span="1.5">
            <el-form-item label="需求部门">
              <el-select clearable v-model="queryParams.demandDept" size="small" :disabled="disable" @focus="chooseOrg('DEPT_PARAM', true, '需求部门')" style="width: 200px">
                <el-option
                  v-for="item in deptOptions"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="1.5">
            <el-form-item label="需求日期">
              <el-date-picker
                v-model="queryParams.demandDate"
                type="date"
                clearable
                value-format="yyyy-MM-dd"
                size="small"
                style="width: 200px"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="1.5">
            <el-form-item label="备注">
              <el-input
                v-model.trim="queryParams.remark"
                size="small"
                clearable
                style="width: 200px"
              />
              </el-form-item>
            </el-col>
        </el-row>
        </div>
      </CollapseTransition>
      </el-form>
      <el-divider class="lines"><i style="cursor: pointer;" :class="expanded?'el-icon-arrow-up':'el-icon-arrow-down'" @click="drop"></i></el-divider>

      <el-card>
        <div class="btn_grooup">
          <el-button type="primary" size="small" @click="addDivision">新增</el-button>

          <el-dropdown size="small" @command="handleCommand">
            <el-button size="small" type="primary" style="margin-left: 10px;">
              导入<i class="el-icon-arrow-down el-icon--right"></i>
            </el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="数据导入">数据导入</el-dropdown-item>
              <el-dropdown-item command="模板下载">模板下载</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>

          <el-dropdown size="small" @command="handleExport">
            <el-button size="small" type="primary" style="margin: 0 10px;">
              导出<i class="el-icon-arrow-down el-icon--right"></i>
            </el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="选中导出">选中导出</el-dropdown-item>
              <el-dropdown-item command="全部导出">全部导出</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>

          <el-button type="primary" size="small" @click="delItems">删除</el-button>
          <!-- <el-button type="primary" size="small">打印</el-button> -->
        </div>
        <el-table 
          :data="tableList" 
          fit
          max-height="350"
          @selection-change="handleSelectionChange"
        >
          <el-table-column show-overflow-tooltip type="selection" width="55" />
          <el-table-column show-overflow-tooltip label="编码" align="center" width="200" prop="code"/>
          <el-table-column show-overflow-tooltip label="需求日期" align="center" width="120" prop="demandDate"/>
          <el-table-column show-overflow-tooltip label="审批结束日期" align="center" width="150" prop="approverFinishTime"/>
          <el-table-column show-overflow-tooltip label="单据状态" align="center" prop="satus" :formatter="formatterStatus"/>
          <!-- <el-table-column show-overflow-tooltip label="是否已处理需求" align="center" width="150" prop="isProcess" /> -->
          <el-table-column show-overflow-tooltip label="业务类型" align="center" prop="billType" :formatter="formatterBillType"/>
          <!-- <el-table-column show-overflow-tooltip label="是否特殊需求" align="center" width="150" prop="isSpeical" /> -->
          <el-table-column show-overflow-tooltip label="需求人员" align="center" prop="demandPersonalName" />
          <el-table-column show-overflow-tooltip label="需求客户" align="center" prop="customerName" width="150"/>
          <el-table-column show-overflow-tooltip label="需求部门" align="center" prop="demandDeptName" width="150"/>
          <!-- <el-table-column show-overflow-tooltip label="供应仓库" align="center" width="120" prop="warehouseName" /> -->
          <!-- <el-table-column show-overflow-tooltip label="供应货位" align="center" width="150" prop="goodsAllocationName" /> -->
          <el-table-column show-overflow-tooltip label="单据来源" align="center" prop="source" width="120" :formatter="formatterSource"/>
          <el-table-column show-overflow-tooltip label="组织" align="center" width="200" prop="orgName"/>
          <el-table-column show-overflow-tooltip label="备注" align="center" width="150" prop="remark" />
          <el-table-column
          fixed="right"
          label="操作"
          align="center"
          width="150"
          >
          <template slot-scope="scope">
            <el-button type="text" size="small" @click="check(scope.row)">查看</el-button>
            <el-button type="text" size="small" v-if="scope.row.status == '0' || scope.row.status == '3'" @click="edit(scope.row)">编辑</el-button>
            <el-button type="text" size="small" v-if="scope.row.status == '0' || scope.row.status == '3'" @click="deleteids(scope.row)">删除</el-button>
          </template>
        </el-table-column>
        </el-table>

        <el-pagination
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
          :current-page="1"
          :page-sizes="[5, 10, 15, 20]"
          :page-size="100"
          layout="total, sizes, prev, pager, next, jumper"
          :total=total>
        </el-pagination>
      </el-card>
    </div>

    <!-- 用户导入对话框 -->
    <el-dialog title="数据导入" :visible.sync="upload.open" width="400px">
      <el-upload
      ref="upload"
      :limit="1"
      accept=".xlsx, .xls"
      :headers="upload.headers"
      :action="upload.url + '?updateSupport=' + upload.updateSupport"
      :disabled="upload.isUploading"
      :on-progress="handleFileUploadProgress"
      :on-success="handleFileSuccess"
      :on-error="errorFile"
      :auto-upload="false"
      drag
      >
      <i class="el-icon-upload"></i>
      <div class="el-upload__text">
        将文件拖到此处，或
        <em>点击上传</em>
      </div>
      <!-- <div class="el-upload__tip" slot="tip">
        <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
      </div> -->
      <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
      <el-button type="primary" @click="submitFileForm">确 定</el-button>
      <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>

    <Add v-model="isList" v-if="!isList" :pageStu="page" :disable="disable" :row="rowDetail" @refresh="resetList"/>
  
    <Refers ref="refer" @doSubmit="selectionsToInput" :single="true"/>
  </div>
</template>

<script>
// 导入的token
import { getToken } from "@/utils/auth";
import Add from './add.vue'
import Refers from '@/components/Refers/refers.vue'
import CollapseTransition from '@/components/MyCollapse/collapse.vue'
import {getDemandList, delDemand, downLoadDemand, exportDemand } from '@/api/purchase/purchaseDemand.js'
export default {
  name: 'PurchaseDemandList',
  components: {
    Add,
    CollapseTransition,
    Refers
  },
  dicts: ['sys_processing_mode', 'sys_status', 'sys_bill_source', 'sys_business', 'sys_reserve_ratio', 'sys_period_unit', 'sys_price_type'],
  data() {
    return {
      // 导入参数
      upload: {
        // 是否显示弹出层（导入）
        open: false,
        // 弹出层标题（导入）
        title: "数据导入",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 1,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/pu/demand/import"
      },
      // 下拉收起配置
      expanded: false,
      // 页面配置
      isList: true,
      // 页面状态
      page: '',
      queryParams: {
        code: '',
        customer: '',
        isProcess: '',
        demandPersonal: '',
        source: '',
        billType: '',
        demandDept: '',
        demandDate: '',
        remark: '',
        pageNum: 1,
        pageSize: 5
      },
      referCondition: {
        type: '',
        isPage: true,
        title: ''
      },
      options: [{
        value: 'Y', label: '是',
      }, {
        value: 'N', label: '否'
      }],
      customerOptions: [],
      personOptions: [],
      deptOptions: [],
      tableList: [],
      total: 0,
      rowDetail: {},
      disable: false,
      ids: []
    }
  },
  created() {
    this.getList(this.queryParams)
  },
  methods: {
    // 格式化表格内容
    formatterStatus(row) {
      switch(row.status){
        case '0':
          return '未提交'
        case '1':
          return '审批中'
        case '2':
          return '已完成'
        case '3':
          return '已驳回'
      }
    },
    formatterBillType(row) {
      switch (row.billType) {
        case 'ZQBH':
          return '周期备货'
        case 'FXXQ':
          return '分销需求'
        case 'TSXQ':
          return '特殊采购需求'
        case 'BDXQ':
          return '补单需求'
        case 'JJXQ':
          return '紧急需求单'
        case 'XPXQ':
          return '新品需求'
        case 'HZBM':
          return '合作部门需求'
      }
    },
    formatterSource(row) {
      switch (row.source) {
        case '1':
          return '手工导入'
        case '2':
          return '按客户计算'
        case '3':
          return '按仓库计算'
        case '4':
          return '手工新增'
      }
    },
    searchList() {
      this.getList(this.queryParams)
    },
    resetList() {
      this.queryParams = {
        code: '',
        customer: '',
        isProcess: '',
        demandPersonal: '',
        source: '',
        billType: '',
        demandDept: '',
        demandDate: '',
        remark: '',
        pageNum: 1,
        pageSize: 5
      }
      this.getList(this.queryParams)
    },
    getList(params){
      getDemandList(params).then(res => {
        if (res.code === 200) {
          this.tableList = res.rows
          this.total = res.total
        }
      })
    },
    handleSelectionChange(selection) {
      console.log('选中', selection)
      this.ids = selection.map(item => item.id)
      console.log('选中数组', this.ids.join())
    },
    handleCommand(command) {
      // alert(command)
      if(command == '模板下载') {
        downLoadDemand({}).then(res => {
          console.log('下载的文件流', res)
          const blob = new Blob([res], {
            type: "application/vnd.ms-excel;charset=UTF-8",
          });// 创建一个类文件对象：Blob对象表示一个不可变的、原始数据的类文件对象
          const downloadElement = document.createElement("a"); //创建a标签
          const href = window.URL.createObjectURL(blob); // 创建下载的链接
          // var temp = res.headers["content-disposition"]; 
          // var fileName = decodeURIComponent(temp.split("filename=")[1]); // 中文需要转码 (前端乱码）
          // var name = fileName.split(";")[0]; //切割成文件名
          downloadElement.href = href;  //下载地址
          downloadElement.download = '模板'; // 下载后文件名
          document.body.appendChild(downloadElement);
          downloadElement.click(); // 点击下载
          document.body.removeChild(downloadElement); // 下载完成移除元素
          window.URL.revokeObjectURL(href); // 释放blob对象
        })
      }
      if (command == '数据导入') {
        this.upload.title = "用户导入"
        this.upload.open = true
      }
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
      this.getList(this.queryParams);
    },
    errorFile(err) {
      this.$modal.notifyError("文件已变动，请重新上传");
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    handleExport(command) {
      if(command == '选中导出') {
        if (this.ids.length == 0) {
          this.$modal.msgWarning("请选中至少一条数据");
        } else {
          let param = {all: false, ids: this.ids}
          exportDemand(param).then(res => {
            const blob = new Blob([res], {
              type: "application/vnd.ms-excel;charset=UTF-8",
            });// 创建一个类文件对象：Blob对象表示一个不可变的、原始数据的类文件对象
            const downloadElement = document.createElement("a"); //创建a标签
            const href = window.URL.createObjectURL(blob); // 创建下载的链接
            // var temp = res.headers["content-disposition"]; 
            // var fileName = decodeURIComponent(temp.split("filename=")[1]); // 中文需要转码 (前端乱码）
            // var name = fileName.split(";")[0]; //切割成文件名
            downloadElement.href = href;  //下载地址
            downloadElement.download = '选中导出'; // 下载后文件名
            document.body.appendChild(downloadElement);
            downloadElement.click(); // 点击下载
            document.body.removeChild(downloadElement); // 下载完成移除元素
            window.URL.revokeObjectURL(href); // 释放blob对象
          })
        }
      } else {
        let param2 = {all: true}
        exportDemand(param2).then(res => {
          const blob = new Blob([res], {
            type: "application/vnd.ms-excel;charset=UTF-8",
          });// 创建一个类文件对象：Blob对象表示一个不可变的、原始数据的类文件对象
          const downloadElement = document.createElement("a"); //创建a标签
          const href = window.URL.createObjectURL(blob); // 创建下载的链接
          // var temp = res.headers["content-disposition"]; 
          // var fileName = decodeURIComponent(temp.split("filename=")[1]); // 中文需要转码 (前端乱码）
          // var name = fileName.split(";")[0]; //切割成文件名
          downloadElement.href = href;  //下载地址
          downloadElement.download = '全部导出'; // 下载后文件名
          document.body.appendChild(downloadElement);
          downloadElement.click(); // 点击下载
          document.body.removeChild(downloadElement); // 下载完成移除元素
          window.URL.revokeObjectURL(href); // 释放blob对象
        })
      }
    },
    addDivision() {
      this.isList = false
      this.page = 'add'
      this.disable = false
    },
    check(row) {
      this.isList = false
      this.page = 'check'
      this.rowDetail = row
      this.disable = true
    },
    edit(row) {
      this.isList = false
      this.page = 'edit'
      this.rowDetail = row
      this.disable = false
    },
    // 行内删除
    deleteids(row) {
      console.log('row', row)
      this.$modal.confirm('确定删除选择数据?').then(() => {
        delDemand(row.id).then(res => {
          if (res.code === 200) {
            this.$modal.msgSuccess("删除成功");
            this.getList(this.queryParams)
          }
        })
        }).catch(() => {})
    },
    // 批量删除按钮
    delItems() {
      if(this.ids.length == 0) {
        this.$modal.msgWarning("请选中至少一条数据");
      } else {
        let param = this.ids.join()
        this.$modal.confirm('确认信息').then(() => {
        delDemand(param).then(res => {
          if (res.code === 200) {
            this.$modal.msgSuccess("删除成功");
            this.getList(this.queryParams)
          }
        })
        }).catch(() => {})
      }
    },
    handleSizeChange(val) {
      console.log(`每页 ${val} 条`);
      this.queryParams.pageSize = val
      this.getList(this.queryParams)
    },
    handleCurrentChange(val) {
      console.log(`当前页: ${val}`);
      this.queryParams.pageNum = val
      this.getList(this.queryParams)
    },
    drop() {
      this.expanded = !this.expanded
    },
    // 搜索区参照选择
    chooseOrg(type, isPage, title) {
      this.referCondition.type = type
      this.referCondition.isPage = isPage
      this.referCondition.title = title
      this.$refs.refer.init(this.referCondition)
    },
    selectionsToInput(selection) {
      if (this.referCondition.type == 'CUSTOMER_PARAM') {
        this.customerOptions = selection
        this.queryParams.customer = selection[0].id
      }
      if (this.referCondition.type == 'CONTACTS_PARAM') {
        this.personOptions = selection
        this.queryParams.demandPersonal = selection[0].id
      }
      if (this.referCondition.type == 'DEPT_PARAM') {
        this.deptOptions = selection
        this.queryParams.demandDept = selection[0].id
      }
    }
  }
}
</script>

<style lang="scss" scoped>
#PurchaseDemandList {
  height: calc(100vh - 84px);
  padding: 12px;
  box-sizing: border-box;
  overflow-y: scroll;
}
.btn_grooup {
  margin-bottom: 10px;
  display: flex;
  justify-content: flex-end;
}
.lines {
  margin-top: 0;
}
</style>